﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows;

namespace WpfApplication1
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		ObservableCollection<CommandViewModel> itemsSource = new ObservableCollection<CommandViewModel>();

		public MainWindow()
		{
			InitializeComponent();
			for (int i = 0; i < 3; i++)
			{
				CommandViewModel viewModel1 = new CommandViewModel();
				viewModel1.Header = i.ToString();
				for (int j = 0; j < 3; j++)
				{
					CommandViewModel viewModel2 = new CommandViewModel();
					viewModel2.Header = i.ToString() + " > " + j.ToString();
					for (int k = 0; k < 3; k++)
					{
						CommandViewModel viewModel3 = new CommandViewModel();
						viewModel3.Header = i.ToString() + " > " + j.ToString() + " > " + k.ToString();
						viewModel2.Children.Add(viewModel3);
					}
					viewModel1.Children.Add(viewModel2);
				}
				this.itemsSource.Add(viewModel1);
			}
			this.panelBar1.ItemsSource = this.itemsSource;
		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			ObservableCollection<CommandViewModel> dataSource = this.panelBar1.ItemsSource as ObservableCollection<CommandViewModel>;
			CommandViewModel level1 = dataSource[0];
			level1.IsExpanded = true;
			CommandViewModel level2 = level1.Children[0];
			level2.IsExpanded = true;
		}
	}

	public class CommandViewModel : INotifyPropertyChanged
	{
		private bool isExpanded;

		public CommandViewModel()
		{
			this.Children = new ObservableCollection<CommandViewModel>();
		}

		public string Header { get; set; }

		public ObservableCollection<CommandViewModel> Children { get; set; }

		public bool IsExpanded
		{
			get
			{
				return this.isExpanded;
			}
			set
			{
				if (this.isExpanded != value)
				{
					this.isExpanded = value;
					this.OnPropertyChanged("IsExpanded");
				}
			}
		}

		public event PropertyChangedEventHandler PropertyChanged;

		private void OnPropertyChanged(string propertyName)
		{
			if (this.PropertyChanged != null)
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}

	}
}
